Index: /bdm/stat/loggers.h
===================================================================
--- /bdm/stat/loggers.h (revision 347)
+++ /bdm/stat/loggers.h (revision 357)
@@ -15,4 +15,5 @@
 
 #include "libBM.h"
+#include "..\user_info.h"
 
 namespace bdm{
@@ -38,5 +39,8 @@
 public:
 	//!Default constructor
-	memlog ( int maxlen0, string itf="" ) : logger(),maxlen ( maxlen0 ),ind ( 0 ),vectors ( 0 ),itfilename(itf) {}
+	memlog ( int maxlen0, string itf="" ) : maxlen ( maxlen0 ),ind ( 0 ),vectors ( 0 ),itfilename(itf) {}
+
+	memlog(): ind ( 0 ),vectors ( 0 ) {}
+
 	//! Initialize storage
 	void init() {
@@ -60,5 +64,23 @@
 	void finalize() {if (itfilename.length()>0) itsave(itfilename.c_str());};
 
+
+	/*! \brief UI for memlog 
+
+	TODO dat tam kam patri, a to celej blok
+
+	\code
+	logger = {
+		type = "itpplog";
+		filename = "file_name.it"; // resulting filename with results in it format
+		maxlen = 100;          // size of memory buffer
+	}
+	\endcode
+	 */
+	void from_setting( const Setting &root );
+
+	// TODO dodelat void to_setting( Setting &root ) const;
 };
+
+UIREGISTER(memlog);
 
 /*!
@@ -69,5 +91,4 @@
 * This format is used to store scalars, hence multivariate RVs must be separated.
 */
-
 class dirfilelog : public memlog {
 
@@ -81,5 +102,8 @@
 	@param dirname0 name of the directory in which to store the results
 	@param maxlen0 length of the memory buffers, when full the buffers will be dumped to HDD and returned to the beginning. */
-	dirfilelog ( std::string dirname0, int maxlen0 ) : memlog ( maxlen0 ), dirname ( dirname0 ), scalarnames ( 0 ) {}
+	dirfilelog ( string dirname0, int maxlen0 ) : memlog ( maxlen0 ), dirname ( dirname0 ), scalarnames ( 0 ) {}
+
+	dirfilelog() {}
+
 	//! Initialize storage
 	void init();
@@ -90,5 +114,21 @@
 	*/
 	void write_buffers ( int Len );
+
+	// TODO dokumentace - aktualizovat
+	/*! \brief UI for dirfilelog (Kst file format) 
+	\code
+	logger = {
+		type = "dirfilelog";
+		dirmane = "directory_for_files"; // resulting files will be stored there
+		maxlen = 100;                    // size of memory buffer, when full results are written to disk
+	}
+	\endcode
+	*/
+	void from_setting( const Setting &root );
+
+	// TODO dodelat void to_setting( Setting &root ) const;
 };
+
+UIREGISTER(dirfilelog);
 
 };
Index: /bdm/stat/libBM.h
===================================================================
--- /bdm/stat/libBM.h (revision 351)
+++ /bdm/stat/libBM.h (revision 357)
@@ -17,39 +17,13 @@
 
 #include "../itpp_ext.h"
-#include "../libconfig/libconfig.h++"
+#include "../bdmroot.h"
+#include "../user_info.h"
 
 
 using namespace libconfig;
-
 using namespace itpp;
 using namespace std;
 
 namespace bdm {
-
-//! Root class of BDM objects
-
-class bdmroot {
-public:
-	//! make sure this is a virtual object
-	virtual ~bdmroot() 
-	{
-	}
-
-	//! This method returns a basic info about the current instance
-	virtual string ToString()
-	{
-		return "";
-	}
-
-	//! This method arrange instance properties according the data stored in the Setting structure
-	virtual void from_setting( const Setting &root )
-	{
-	}
-
-	//! This method save all the instance properties into the Setting structure 
-	virtual void to_setting( Setting &root ) const
-	{	
-	}
-};
 
 typedef std::map<string, int> RVmap;
@@ -57,5 +31,5 @@
 extern Array<string> RV_NAMES;
 
-//! Structure of RV (used internally), i.e. expanded RVs
+//! Structure of RV (used internally), i.e. expanded RVs - TODO tak proc je ve verejnem prostoru jmen? upravit
 class str {
 public:
@@ -189,5 +163,5 @@
 	//!@{
 
-	//! generate \c str from rv, by expanding sizes
+	//! generate \c str from rv, by expanding sizes TODO to_string.. 
 	str tostr() const;
 	//! when this rv is a part of bigger rv, this function returns indeces of self in the data vector of the bigger crv.
@@ -201,6 +175,25 @@
 	//!@}
 
-};
-
+	// TODO aktualizovat dle soucasneho UI
+	/*! \brief UI for class RV (description of data vectors)
+
+	\code
+	rv = {
+		type = "rv"; //identifier of the description
+		// UNIQUE IDENTIFIER same names = same variable
+		names = ["a", "b", "c", ...];   // which will be used e.g. in loggers 
+
+		//optional arguments
+		sizes = [1, 2, 3, ...];         // (optional) default = ones()
+		times = [-1, -2, 0, ...];       // time shifts with respect to current time (optional) default = zeros()
+	}
+	\endcode
+	*/
+	void from_setting( const Setting &root );
+
+	// TODO dodelat void to_setting( Setting &root ) const;
+};
+
+UIREGISTER(RV);
 
 //! Concat two random variables
Index: /bdm/stat/libDS.cpp
===================================================================
--- /bdm/stat/libDS.cpp (revision 313)
+++ /bdm/stat/libDS.cpp (revision 357)
@@ -1,4 +1,6 @@
 
 #include "libDS.h"
+#include "..\user_info.h"
+
 using namespace bdm;
 
@@ -53,4 +55,39 @@
 }
 
+void ArxDS::from_setting( const Setting &root ) 
+{	
+	RV *yrv = UI::build<RV>( root, "y" );
+	RV *urv = UI::build<RV>( root, "u" );
+	RV *rrv = UI::build<RV>( root, "rgr" ); 
+				
+	mat Th;
+	UI::get( Th, root, "theta" );
+
+	vec mu0;
+	if( root.exists( "offset" ))
+		UI::get( mu0, root, "offset" );
+	else
+		mu0= zeros( yrv->_dsize() );
+
+	mat sqR;
+	UI::get( sqR, root, "r" );
+	set_parameters(Th,mu0,sqR);
+	set_drv(*yrv,*urv,*rrv);
+
+	if(root.exists("opt"))
+		set_options(root["opt"]);
+}
+
+/*void ArxDS::to_setting( Setting &root ) const
+{	
+	Transport::to_setting( root );
+
+	Setting &kilometers_setting = root.add("kilometers", Setting::TypeInt );
+	kilometers_setting = kilometers;
+
+	UI::save( passengers, root, "passengers" );
+}*/
+
+
 CsvFileDS::CsvFileDS ( const string& fname, const string& orientation ) :FileDS() {
         time = 0;
@@ -87,2 +124,49 @@
 }
 
+void ITppFileDS::from_setting( const Setting &root ) 
+{	
+	RV* rvtmp = UI::build<RV>(root, "rv" );
+
+	it_file it ( root["filename"] );
+	it << Name ( root["varname"] ); 
+	it >> Data;
+	time = 0;
+	//rowid and delays are ignored
+
+	set_drv(*rvtmp,RV());
+}
+
+/*void ITppFileDS::to_setting( Setting &root ) const
+{	
+	Transport::to_setting( root );
+
+	Setting &kilometers_setting = root.add("kilometers", Setting::TypeInt );
+	kilometers_setting = kilometers;
+
+	UI::save( passengers, root, "passengers" );
+}*/
+
+void stateDS::from_setting( const Setting &root ) 
+{	
+	IM = UI::build<mpdf>(root, "IM");
+	OM = UI::build<mpdf>(root, "OM");
+
+	dt.set_length( OM->dimension() );
+	xt.set_length( IM->dimension() );
+	ut.set_length(0);
+	
+	RV* rvtmp = UI::build<RV>(root["IM"], "rvu");			
+	//set_drv(rvtmp);
+}
+
+/*void stateDS::to_setting( Setting &root ) const
+{	
+	Transport::to_setting( root );
+
+	Setting &kilometers_setting = root.add("kilometers", Setting::TypeInt );
+	kilometers_setting = kilometers;
+
+	UI::save( passengers, root, "passengers" );
+}*/
+
+
Index: /bdm/CMakeLists.txt
===================================================================
--- /bdm/CMakeLists.txt (revision 345)
+++ /bdm/CMakeLists.txt (revision 357)
@@ -7,3 +7,3 @@
 
 # Normal BDM library
-add_library (bdm STATIC itpp_ext.cpp itpp_ext.h osutils.cpp osutils.h ${BdmMath} ${BdmStat} ${BdmEstim} ${BdmUI})
+add_library (bdm STATIC bdmroot.cpp bdmroot.h itpp_ext.cpp itpp_ext.h osutils.cpp osutils.h ${BdmMath} ${BdmStat} ${BdmEstim} ${BdmUI})
Index: /tests/testUI.cpp
===================================================================
--- /tests/testUI.cpp (revision 357)
+++ /tests/testUI.cpp (revision 357)
@@ -0,0 +1,228 @@
+
+#include <string>
+#include "user_info.h"
+
+using std::string;
+using namespace std;
+using namespace bdm;
+
+class Passenger : public bdmroot
+{
+public:
+
+  Passenger() {
+  }
+};
+
+class Human : public Passenger
+{
+public:
+  string name;
+
+  Human() {
+    name = "none";
+  }
+
+  virtual void from_setting(const Setting &root) {
+    root.lookupValue("name", name);
+  }
+
+  virtual void to_setting(Setting &root) const {
+    Setting &name_setting = root.add("name", Setting::TypeString);
+    name_setting = name;
+  }
+
+  string to_string() {
+    return name;
+  }
+};
+
+UIREGISTER(Human);
+
+class Robot : public Passenger
+{
+public:
+  int number;
+  Array<string> software;
+
+  Robot() : software() {
+    number = -1;
+  }
+
+  virtual void from_setting(const Setting &root) {
+    root.lookupValue("number", number);
+	if( root.exists( "software" ) )
+		UI::get(software, root, "software");
+  }
+
+  virtual void to_setting(Setting &root) const {
+    Setting &number_setting = root.add("number", Setting::TypeInt);
+    number_setting = number;
+
+    UI::save(software, root, "software");
+  }
+
+  string to_string() {
+    stringstream stream;
+    stream << number;
+    for (int i = 0; i < software.length(); i++)
+      stream << "_" + software(i);
+    return stream.str();
+  }
+};
+
+UIREGISTER(Robot);
+
+class Transport : public bdmroot
+{
+public:
+  int year;
+  string manufacturer;
+
+  Transport() {
+    year = 1900;
+    manufacturer = "unknown";
+  }
+
+  Transport(int year, string manufacturer)
+      : year(year), manufacturer(manufacturer) {
+  }
+
+  virtual void from_setting(const Setting &root) {
+    root.lookupValue("year", year);
+    root.lookupValue("manufacturer", manufacturer);
+  }
+
+  virtual void to_setting(Setting &root) const {
+    Setting &year_setting = root.add("year", Setting::TypeInt);
+    year_setting = year;
+
+    Setting &manufacturer_setting = root.add("manufacturer", Setting::TypeString);
+    manufacturer_setting = manufacturer;
+  }
+};
+
+class Car : public Transport
+{
+public:
+  int kilometers;
+  Array<Passenger*> passengers;
+
+  Car() : Transport() {
+    kilometers = 0;
+  }
+
+
+  Car(int year, string manufacturer, int kilometers)
+      : Transport(year, manufacturer), kilometers(kilometers) {
+  }
+
+  virtual void from_setting(const Setting &root) {
+    Transport::from_setting(root);
+
+    root.lookupValue("kilometers", kilometers);
+
+	if( root.exists( "passengers" ) )
+	    UI::get(passengers, root, "passengers");
+  }
+
+  virtual void to_setting(Setting &root) const {
+    Transport::to_setting(root);
+
+    Setting &kilometers_setting = root.add("kilometers", Setting::TypeInt);
+    kilometers_setting = kilometers;
+
+    UI::save(passengers, root, "passengers");
+  }
+
+  string to_string() {
+    stringstream stream;
+    stream << "A car made in " << year << " by " << manufacturer << ", having " << kilometers << " kilometers on the clock.";
+    if (passengers.length()) {
+      stream << "The names of passengers are as follows: ";
+      for (int i = 0; i < passengers.length(); i++)
+        stream << passengers(i)->to_string() << " ";
+    }
+    return stream.str();
+  }
+};
+
+UIREGISTER(Car);
+
+class Bike : public Transport
+{
+public:
+  bool electricLights;
+  mat matr;
+
+  Bike() : Transport(), matr("2,2;3,4") {
+    electricLights = false;
+  }
+
+  Bike(int year, string manufacturer, bool electricLights)
+      : Transport(year, manufacturer), electricLights(electricLights) {
+  }
+
+  ~Bike() {
+  }
+
+  void from_setting(const Setting &root) {
+    Transport::from_setting(root);
+
+    root.lookupValue("electricLights", electricLights);
+
+	UI::get(matr, root, "matr");
+  }
+
+  void to_setting(Setting &root) const {
+    Transport::to_setting(root);
+
+    Setting &electricLights_setting = root.add("electricLights", Setting::TypeBoolean);
+    electricLights_setting = electricLights;
+
+    UI::save(matr, root, "matr");
+  }
+
+  string to_string() {
+    stringstream stream;
+    stream << "a bike made in " << year << " by " << manufacturer;
+    if (electricLights) stream << " with electric lights included";
+    return stream.str();
+  }
+};
+
+UIREGISTER(Bike);
+
+int main()
+{
+  //////////////////////////////////// LOADING ////////////////////////////////
+  UI_File in("testUI_in.cfg");
+  Transport *pepikovo = UI::build<Transport>(in, "pepikovo");
+  cout << "pepikovo: " << pepikovo->to_string() << endl;
+  Transport *jardovo = UI::build<Transport>(in, "jardovo");
+  cout << "jardovo: " << jardovo->to_string() << endl;
+  Transport *ondrejovo = UI::build<Transport>(in, "ondrejovo");
+  cout << "ondrejovo: " << ondrejovo->to_string() << endl;
+  Transport *elisky = UI::build<Transport>(in, "elisky");
+  cout << "elisky: " << elisky->to_string() << endl;
+  Transport *kati = UI::build<Transport>(in, "kati");
+  cout << "kati: " << kati->to_string() << endl;
+  getchar();
+
+  /////////////////////////////////// SAVING //////////////////////////
+
+  Car audi(1968, "zyl", 200);
+  Car liaz(1989, "skoda", 1000);
+  Bike author(2001, "noname", false);
+  UI_File out;
+
+  UI::save(&audi, out, "marty");
+  UI::save(&liaz, out, "bohousovo");
+  UI::save(&author, out, "karlovo");
+  UI::save(pepikovo, out, "pepikovo");
+  out.save("testUI_out.cfg");
+
+  cout << "all the transport means were saved correctly" << endl;
+  getchar();
+  return 0;
+}
Index: /tests/testUI_in.cfg
===================================================================
--- /tests/testUI_in.cfg (revision 357)
+++ /tests/testUI_in.cfg (revision 357)
@@ -0,0 +1,31 @@
+pepikovo : 
+{
+  class = "Car";
+  year = 1998;
+  manufacturer = "audi";
+  kilometers = 25000;
+  passengers = ( 
+	{ class = "Human"; 
+	   name = "Karlos Novak"; }, 
+	{ class = "Robot"; 
+	   software = ( "CygWin", "Matlab", "Aimsun" ); }, 
+	{ class = "Human"; 
+	   name = "Karlosik Novacek"; } );
+};
+jardovo : 
+{
+  class = "Car";
+  year = 1992;
+  manufacturer = "liaz";
+  kilometers = 1555000;
+};
+ondrejovo : 
+{
+  class = "Bike";
+  year = 1996;
+  manufacturer = "author";
+  electricLights = true;
+  matr = ( 2, 2, [ 1.0, 0.0, 0.0, 1.0 ] );
+};
+elisky = "jardovo";
+kati = "skubankovo@testUI_ex.cfg";
Index: /tests/testUI_ex.cfg
===================================================================
--- /tests/testUI_ex.cfg (revision 357)
+++ /tests/testUI_ex.cfg (revision 357)
@@ -0,0 +1,7 @@
+skubankovo : 
+{
+  class = "Car";
+  year = 1980;
+  manufacturer = "vecernicek";
+  kilometers = 250000;
+};
Index: /tests/CMakeLists.txt
===================================================================
--- /tests/CMakeLists.txt (revision 322)
+++ /tests/CMakeLists.txt (revision 357)
@@ -12,4 +12,5 @@
 EXEC(datalink_test)
 EXEC(loggers_test)
+EXEC(testUI)
 
 EXEC(chmat_test)
@@ -39,4 +40,3 @@
 EXEC(blas_test)
 
-add_subdirectory(UI)
 add_subdirectory(tutorial)
Index: /library/tutorial/arx_mex_test.cfg
===================================================================
--- /library/tutorial/arx_mex_test.cfg (revision 278)
+++ /library/tutorial/arx_mex_test.cfg (revision 357)
@@ -11,8 +11,8 @@
 //estimation
 estimator = {
-   type = "ARXest";
-	y = {type="rv"; names=["y"]; };
-	rgr = {type="rv";
-		names = ["y","y","y","u"];
+   type = "ARX";
+	y = {type="RV"; names=("y"); };
+	rgr = {type="RV";
+		names = ("y","y","y","u");
 		times = [-1, -2, -3, -1];
 	};
Index: /library/tutorial/arx_test.cfg
===================================================================
--- /library/tutorial/arx_test.cfg (revision 278)
+++ /library/tutorial/arx_test.cfg (revision 357)
@@ -1,19 +1,19 @@
 //Data generating system
 system = {
-	type = "ArxDS";
-	y = {type="rv"; names=["y", "u"];};
-	u = {type="rv"; names=[]; };
-	rgr = {type="rv";
-		names = ["y","y","y","u"];
+	class = "ArxDS";
+	y = {class="RV"; names=("y", "u");};
+	u = {class="RV"; names=(); };
+	rgr = {class="RV";
+		names = ("y","y","y","u");
 		times = [-1, -2, -3, -1];
 	};
 	//AR parameters
-	theta = [0.8, -0.3, 0.4, 1.0,
-	         0.0, 0.0, 0.0, 0.0];
+	theta = (2,4,[0.8, -0.3, 0.4, 1.0,
+	              0.0, 0.0, 0.0, 0.0]);
 	// offset
 	offset = [0.0, 0.0];
 	//variance
-	r = [0.1, 0.0,
-	     0.0, 1.0];
+	r = (2,2,[0.1, 0.0,
+	         0.0, 1.0] );
 	// log also theta
 	opt="L_theta";
@@ -22,5 +22,5 @@
 //store results
 logger = {
-	type= "dirfilelog";
+	class= "dirfilelog";
 	dirname = "exp/arx_ui";
 	maxlen = 1000; //
@@ -29,8 +29,8 @@
 //estimation
 estimator = {
-	type = "ARXest";
-	y = {type="rv"; names=["y"]; };
-	rgr = {type="rv";
-		names = ["y","y","y","u"];
+	class = "ARX";
+	y = {class="RV"; names=("y"); };
+	rgr = {class="RV";
+		names = ("y","y","y","u");
 		times = [-1, -2, -3, -1];
 	};
Index: /library/estimator.cpp
===================================================================
--- /library/estimator.cpp (revision 281)
+++ /library/estimator.cpp (revision 357)
@@ -48,6 +48,8 @@
  */
 
-#include <stat/libDS_ui.h>
-#include <estim/arx_ui.h>
+#include "stat/libDS.h"
+#include "estim/arx.h"
+#include "user_info.h"
+#include "stat/loggers.h"
 
 using namespace bdm;
@@ -59,20 +61,13 @@
 	else {
 		cout << "Missing configuration file.\n Usage: \n $> estimator config_file.cfg";
-		abort();
+		//abort();
 	}
-	UIFile F ( fname );
+	fname = "arx_test.cfg";
+	UI_File F ( fname );
 
-	logger* L;
-	ArxDS * DS;
-	BM* E;
-	int Ndat;
-
-	try {
-		UIbuild ( F.lookup ( "logger" ),L );
-		UIbuild ( F.lookup ( "system" ),DS );
-		F.lookupValue ( "experiment.ndat",Ndat );
-		UIbuild ( F.lookup ( "estimator" ),E );
-	}
-	catch UICATCH;
+	logger* L = UI::build<logger>( F, "logger");
+	ArxDS * DS = UI::build<ArxDS>( F, "system" );
+	BM* E = UI::build<BM>( F, "estimator" );
+	int Ndat = F.lookupValue ( "experiment.ndat",Ndat );
 
 	DS->log_add ( *L );
Index: /system/FindMatlab.cmake
===================================================================
--- /system/FindMatlab.cmake (revision 357)
+++ /system/FindMatlab.cmake (revision 357)
@@ -0,0 +1,120 @@
+# - this module looks for Matlab
+# Defines:
+#  MATLAB_INCLUDE_DIR: include path for mex.h, engine.h
+#  MATLAB_LIBRARIES:   required libraries: libmex, etc
+#  MATLAB_MAT_LIBRARY: path to libmat.lib
+#  MATLAB_MEX_LIBRARY: path to libmex.lib
+#  MATLAB_MX_LIBRARY:  path to libmx.lib
+#  MATLAB_ENG_LIBRARY: path to libeng.lib
+
+
+SET(MATLAB_FOUND 0)
+IF(WIN32)
+  IF(${CMAKE_GENERATOR} MATCHES "Visual Studio .*" OR ${CMAKE_GENERATOR} MATCHES "NMake Makefiles")
+    SET(MATLAB_ROOT "[HKEY_LOCAL_MACHINE\\SOFTWARE\\MathWorks\\MATLAB\\7.0;MATLABROOT]/extern/lib/win32/microsoft/")
+  ELSE(${CMAKE_GENERATOR} MATCHES "Visual Studio .*" OR ${CMAKE_GENERATOR} MATCHES "NMake Makefiles")
+      IF(${CMAKE_GENERATOR} MATCHES "Borland")
+        # Same here, there are also: bcc50 and bcc51 directories
+        SET(MATLAB_ROOT "[HKEY_LOCAL_MACHINE\\SOFTWARE\\MathWorks\\MATLAB\\7.0;MATLABROOT]/extern/lib/win32/microsoft/bcc54")
+      ELSE(${CMAKE_GENERATOR} MATCHES "Borland")
+        MESSAGE(FATAL_ERROR "Generator not compatible: ${CMAKE_GENERATOR}")
+      ENDIF(${CMAKE_GENERATOR} MATCHES "Borland")
+  ENDIF(${CMAKE_GENERATOR} MATCHES "Visual Studio .*" OR ${CMAKE_GENERATOR} MATCHES "NMake Makefiles")
+  FIND_LIBRARY(MATLAB_MEX_LIBRARY
+    libmex
+    ${MATLAB_ROOT}
+    )
+  FIND_LIBRARY(MATLAB_MX_LIBRARY
+    libmx
+    ${MATLAB_ROOT}
+    )
+  FIND_LIBRARY(MATLAB_ENG_LIBRARY
+    libeng
+    ${MATLAB_ROOT}
+    )
+  FIND_LIBRARY(MATLAB_MAT_LIBRARY
+    libmat
+    ${MATLAB_ROOT}
+    )
+
+  FIND_PATH(MATLAB_INCLUDE_DIR
+    "mex.h"
+    "[HKEY_LOCAL_MACHINE\\SOFTWARE\\MathWorks\\MATLAB\\7.0;MATLABROOT]/extern/include"
+    )
+ELSE( WIN32 )
+  IF(NOT MATLAB_ROOT)
+    IF($ENV{MATLAB_ROOT})
+      SET(MATLAB_ROOT $ENV{MATLAB_ROOT})
+    ELSE($ENV{MATLAB_ROOT})
+      SET(MATLAB_ROOT /opt/matlab)
+    ENDIF($ENV{MATLAB_ROOT})    
+  ENDIF(NOT MATLAB_ROOT)
+  IF(CMAKE_SIZEOF_VOID_P EQUAL 4)
+    # Regular x86
+    SET(MATLAB_SYS
+      ${MATLAB_ROOT}/bin/glnx86
+      )
+  ELSE(CMAKE_SIZEOF_VOID_P EQUAL 4)
+    # AMD64:
+    SET(MATLAB_SYS
+      ${MATLAB_ROOT}/bin/glnxa64
+      )
+  ENDIF(CMAKE_SIZEOF_VOID_P EQUAL 4)
+  FIND_LIBRARY(MATLAB_MEX_LIBRARY
+    mex
+    ${MATLAB_SYS}
+    )
+  FIND_LIBRARY(MATLAB_MX_LIBRARY
+    mx
+    ${MATLAB_SYS}
+    )
+  FIND_LIBRARY(MATLAB_MAT_LIBRARY
+    mat
+    ${MATLAB_SYS}
+    )
+  FIND_LIBRARY(MATLAB_ENG_LIBRARY
+    eng
+    ${MATLAB_SYS}
+    )
+  FIND_PATH(MATLAB_INCLUDE_DIR
+    "mex.h"
+    ${MATLAB_ROOT}/extern/include
+    )
+
+ENDIF(WIN32)
+
+# This is common to UNIX and Win32:
+SET(MATLAB_LIBRARIES
+  ${MATLAB_MEX_LIBRARY}
+  ${MATLAB_MX_LIBRARY}
+  ${MATLAB_ENG_LIBRARY}
+)
+
+IF(MATLAB_INCLUDE_DIR 
+    AND MATLAB_MEX_LIBRARY 
+    AND MATLAB_MAT_LIBRARY
+    AND MATLAB_ENG_LIBRARY
+    AND MATLAB_MX_LIBRARY)
+  SET(MATLAB_LIBRARIES ${MATLAB_MX_LIBRARY} ${MATLAB_MEX_LIBRARY} ${MATLAB_ENG_LIBRARY} ${MATLAB_MAT_LIBRARY})
+ENDIF(MATLAB_INCLUDE_DIR 
+    AND MATLAB_MEX_LIBRARY 
+    AND MATLAB_MAT_LIBRARY
+    AND MATLAB_ENG_LIBRARY
+    AND MATLAB_MX_LIBRARY)
+
+MARK_AS_ADVANCED(
+  MATLAB_MEX_LIBRARY
+  MATLAB_MX_LIBRARY
+  MATLAB_ENG_LIBRARY
+  MATLAB_INCLUDE_DIR
+  MATLAB_ROOT
+)
+
+INCLUDE(FindPackageHandleStandardArgs)
+FIND_PACKAGE_HANDLE_STANDARD_ARGS(Matlab 
+    MATLAB_INCLUDE_DIR 
+    MATLAB_MEX_LIBRARY 
+    MATLAB_MAT_LIBRARY
+    MATLAB_ENG_LIBRARY
+    MATLAB_MX_LIBRARY )
+
Index: /system/FindACML.cmake
===================================================================
--- /system/FindACML.cmake (revision 357)
+++ /system/FindACML.cmake (revision 357)
@@ -0,0 +1,43 @@
+# - Find ACML
+# Find the native ACML includes and library
+# This module defines
+#  ACML_INCLUDE_DIR, where to find acml.h, etc.
+#  ACML_LIBRARIES, the libraries needed to use ACML.
+#  ACML_FOUND, If false, do not try to use ACML.
+# also defined, but not for general use are
+#  ACML_LIBRARY, where to find the ACML library.
+
+FIND_PATH(ACML_INCLUDE_DIR acml.h
+	"${ACML_DIR}\\pgi32\\include"
+ )
+
+FIND_LIBRARY(ACML_LIBRARY
+  NAMES libacml_dll
+  PATHS "${ACML_DIR}\\pgi32\\lib"
+  )
+
+IF (ACML_LIBRARY AND ACML_INCLUDE_DIR)
+    SET(ACML_LIBRARIES ${ACML_LIBRARY})
+    SET(ACML_FOUND "YES")
+ELSE (ACML_LIBRARY AND ACML_INCLUDE_DIR)
+  SET(ACML_FOUND "NO")
+ENDIF (ACML_LIBRARY AND ACML_INCLUDE_DIR)
+
+
+IF (ACML_FOUND)
+   IF (NOT ACML_FIND_QUIETLY)
+      MESSAGE(STATUS "Found ACML: ${ACML_LIBRARIES}")
+   ENDIF (NOT ACML_FIND_QUIETLY)
+ELSE (ACML_FOUND)
+   IF (ACML_FIND_REQUIRED)
+      MESSAGE(FATAL_ERROR "Could not find ACML library")
+   ENDIF (ACML_FIND_REQUIRED)
+ENDIF (ACML_FOUND)
+
+# Deprecated declarations.
+GET_FILENAME_COMPONENT (NATIVE_ACML_LIB_PATH ${ACML_LIBRARY} PATH)
+
+MARK_AS_ADVANCED(
+  ACML_LIBRARY
+  ACML_INCLUDE_DIR
+  )
Index: /system/FindITPP.cmake
===================================================================
--- /system/FindITPP.cmake (revision 357)
+++ /system/FindITPP.cmake (revision 357)
@@ -0,0 +1,54 @@
+# - Find ITPP
+# Find the native ITPP includes and library
+# This module defines
+#  ITPP_INCLUDE_DIR, where to find itpp/itbase.h, etc.
+#  ITPP_LIBRARIES, the libraries needed to use ITPP.
+#  ITPP_FOUND, If false, do not try to use ITPP.
+# also defined, but not for general use are
+#  ITPP_LIBRARY, where to find the ITPP library.
+
+MESSAGE("ITPP_DIR set to ${ITPP_DIR}" )
+
+FIND_PATH(ITPP_INCLUDE_DIR itpp/itbase.h
+	${ITPP_DIR}
+#	/usr/pkgs64/include
+#	/usr/include
+  NO_DEFAULT_PATH
+  )
+
+FIND_LIBRARY(ITPP_LIBRARY
+  NAMES itpp #itpp_debug
+  PATHS ${ITPP_DIR}/libs
+  ${ITPP_DIR}/itpp/.libs/
+  "${ITPP_DIR}\\win32\\lib"
+ # /usr/pkgs64/lib
+ # /usr/lib64
+ # /usr/lib
+  NO_DEFAULT_PATH
+)
+
+IF (ITPP_LIBRARY AND ITPP_INCLUDE_DIR)
+    SET(ITPP_LIBRARIES ${ITPP_LIBRARY})
+    SET(ITPP_FOUND "YES")
+ELSE (ITPP_LIBRARY AND ITPP_INCLUDE_DIR)
+  SET(ITPP_FOUND "NO")
+ENDIF (ITPP_LIBRARY AND ITPP_INCLUDE_DIR)
+
+
+IF (ITPP_FOUND)
+   IF (NOT ITPP_FIND_QUIETLY)
+      MESSAGE(STATUS "Found ITPP: ${ITPP_LIBRARIES}")
+   ENDIF (NOT ITPP_FIND_QUIETLY)
+ELSE (ITPP_FOUND)
+   IF (ITPP_FIND_REQUIRED)
+      MESSAGE(FATAL_ERROR "Could not find ITPP library")
+   ENDIF (ITPP_FIND_REQUIRED)
+ENDIF (ITPP_FOUND)
+
+# Deprecated declarations.
+GET_FILENAME_COMPONENT (NATIVE_ITPP_LIB_PATH ${ITPP_LIBRARY} PATH)
+
+MARK_AS_ADVANCED(
+  ITPP_LIBRARY
+  ITPP_INCLUDE_DIR
+  )
Index: /doc/local/codingrules.dox
===================================================================
--- /doc/local/codingrules.dox (revision 33)
+++ /doc/local/codingrules.dox (revision 357)
@@ -8,30 +8,19 @@
 \section cr_variables Default Naming Rules for Variables
 
-Variables are named using lower-case letters and words are separated
-using under-score. Abbreviations, when used in variable names, are also
-written with lower-case letters. Examples:
+Generally, variables are named using lower-case letters and words are separated using
+under-score. But there are many exceptions, for instance abbreviations or classical 
+matematical notations. Therefore, coding rules for variables are quite free. Examples:
 
 <ul>
-<li> \c `fft_size' </li>
-<li> \c `nrof_paths' </li>
-<li> \c `my_variable_name' </li>
+<li> \c `FFT_size' </li>
+<li> \c `initial_RV' </li>
+<li> \c `my_variable' </li>
 </ul>
-
-Some variable names or parts of variable names are commonly used in
-several different functions and files to denote the same thing. For
-instance the following common names and prefixes should be used:
-
-<ul>
-<li> \c `rows' - number of rows in a matrix </li>
-<li> \c `cols' - number of columns in a matrix </li>
-<li> \c `nrof_' - number of ... </li>
-</ul>
-
 
 \section cr_files Default Naming Rules for Files
 
 Files are named using lower-case letters and words are separated using
-under-score. Abbreviations, when used in file names, are also written
-with lower-case letters.
+under-score. If an abbreviation is inevitable within file name, it is written with 
+lower-case letters. 
 
 Source files are named using <tt>`.cpp'</tt> suffix, whereas header
@@ -40,7 +29,34 @@
 <ul>
 <li> <tt>`my_file.h'</tt> </li>
-<li> <tt>`my_file.cpp'</tt> </li>
+<li> <tt>`user_info.cpp'</tt> </li>
 </ul>
 
+\section cr_file_templates Form of the source files
+
+For all the library classes, both header file `[filename].h' and source file 
+`[filename].cpp' should be implemented. And the following few rules should be 
+respected   
+
+<ul>
+
+<li> if possible, each `#inline ... ' dircetive should be located within the `.h'
+file, one obvious exception is the case of `#inline [filename].h' written in 
+`[filename].cpp' </li>
+
+<li> firstly, system headers should be included (i.e. those with brackets 
+`#include <header_name>'), other headers (like `#include my_header_name.h') 
+should follow (this rule leads to the faster search of an error on some 
+compilators) </li>
+
+<li> source code itself should be placed in the `.cpp' file, `.h' should 
+contains only class declarations and documentation (this rule has a few exceptions like
+ inline functions, templates and some extremely short function bodies)</li>
+
+</ul>
+
+Rules considering formatting of the source code itself are stored in the 
+file \system\astylerc, which is a configuration file for code formating 
+utility named ASTYLE. To apply them, download the proper version from 
+its web page http://astyle.sourceforge.net/     
 
 \section cr_functions Default Naming Rules for Functions
@@ -71,10 +87,10 @@
 
 Each new word in a class or structure name should always start with a
-capital letter and the words should be separated with an
-under-score. Abbreviations are written with capital letters. Examples:
+capital letter and the words should not be separated. Abbreviations are 
+written with capital letters. Examples:
 
 <ul>
-<li> \c `My_Class_Name' </li>
-<li> \c	`My_Struct_Name' </li>
+<li> \c `MyClassName' </li>
+<li> \c `MyStructName' </li>
 <li> \c `OFDM' </li>
 </ul>
Index: /doc/local/library_structure.dox
===================================================================
--- /doc/local/library_structure.dox (revision 357)
+++ /doc/local/library_structure.dox (revision 357)
@@ -0,0 +1,17 @@
+/*!
+\page library_structure Library structure >> UNDER CONSTRUCTION <<
+
+Here you find basic infromation about the library subdirectories.
+
+Description of the library subdirectories
+<ul>
+<li> source:\system -- a directory containing ..., </li>
+<li> source:\system\win32 -- a directory containing ..., </li>
+<li> source:\system\linux -- a directory containing ...,</li>
+</ul>
+ 
+
+// \section cr_variables Default Naming Rules for Variables
+
+
+*/
Index: /applications/doprava/k1.cpp
===================================================================
--- /applications/doprava/k1.cpp (revision 341)
+++ /applications/doprava/k1.cpp (revision 357)
@@ -13,9 +13,9 @@
 
 #include <estim/ekf_templ.h>
-#include <stat/loggers_ui.h>
-#include <stat/libDS_ui.h>
 
 //include dopravni model
 #include "model.h"
+#include "stat\libDS.h"
+#include "stat\loggers.h"
 
 using namespace bdm;
